/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.17 by edhill, Tue Oct 21 20:10:12 2003 UTC revision 1.85 by edhill, Wed Jul 14 21:26:53 2004 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env sh
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          printf "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 62  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -e Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    %.$tfs : %.F
128    .SUFFIXES:
129    genmake_hello.$tfs: genmake_hello.F
130            $LN genmake_hello.F genmake_hello.$tfs
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -e "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -e Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161    look_for_makedepend()  {
162    
163        #  The "original" makedepend is part of the Imake system that is
164        #  most often distributed with XFree86 or with an XFree86 source
165        #  package.  As a result, many machines (eg. generic Linux) do not
166        #  have a system-default "makedepend" available.  For those
167        #  systems, we have two fall-back options:
168        #
169        #    1) a makedepend implementation shipped with the cyrus-imapd
170        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
171        #
172        #    2) a known-buggy xmakedpend shell script
173        #
174        #  So the choices are, in order:
175        #
176        #    1) use the user-specified program
177        #    2) use a system-wide default
178        #    3) locally build and use the cyrus implementation
179        #    4) fall back to the buggy local xmakedpend script
180        #
181        if test "x${MAKEDEPEND}" = x ; then
182            which makedepend > /dev/null 2>&1
183            RV0=$?
184            cat <<EOF >> genmake_tc.f
185          program test
186          write(*,*) 'test'
187          stop
188          end
189    EOF
190            makedepend genmake_tc.f > /dev/null 2>&1
191            RV1=$?
192            if test "x${RV0}${RV1}" = x00 ; then
193                MAKEDEPEND=makedepend
194            else
195                echo "    a system-default makedepend was not found."
196                
197                #  Try to build the cyrus implementation
198                rm -f ./genmake_cy_md
199                (
200                    cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
201                        &&  ./configure > /dev/null 2>&1  \
202                        &&  make > /dev/null 2>&1
203                    if test -x ./makedepend.exe ; then
204                        $LN ./makedepend.exe ./makedepend
205                    fi
206                    ./makedepend ifparser.c > /dev/null 2>&1  \
207                        &&  echo "true"
208                ) > ./genmake_cy_md
209                grep true ./genmake_cy_md > /dev/null 2>&1
210                RETVAL=$?
211                if test "x$RETVAL" = x0 ; then
212                    MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
213                else
214                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
215                fi
216                rm -f ./genmake_cy_md
217            fi
218        fi
219    }
220    
221    
222  # Guess possible config options for this host  # Guess possible config options for this host
223  find_possible_configs()  {  find_possible_configs()  {
224    
225      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
226      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
227      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
228        tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
229        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
230        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
231        PLATFORM=$tmp3
232        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
233      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
234      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
235            
236      echo "test" > test      echo "test" > test
237      ln -s ./test link      ln -s ./test link
# Line 103  find_possible_configs()  { Line 249  find_possible_configs()  {
249          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
250      fi      fi
251    
252        look_for_makedepend
253    
254      # look for possible fortran compilers      # look for possible fortran compilers
255      tmp="$MITGCM_FC $FC g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
256      p_FC=      p_FC=
257      for c in $tmp ; do      for c in $tmp ; do
258          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 121  EOF Line 269  EOF
269              p_FC="$p_FC $c"              p_FC="$p_FC $c"
270          fi          fi
271      done      done
272        rm -f ./hello.f ./hello
273      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
274          cat 1>&2 <<EOF          cat 1>&2 <<EOF
275    
# Line 137  EOF Line 286  EOF
286          echo "   "$p_FC          echo "   "$p_FC
287          if test "x$FC" = x ; then          if test "x$FC" = x ; then
288              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
289                echo "  Setting FORTRAN compiler to: "$FC
290          fi          fi
291      fi      fi
292    
293      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
294          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
295          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
296              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
297              echo "  The options file:  $p_OF"          fi
298              echo "    appears to match so we'll use it."      fi
299              break  #    echo "  The options file:  $p_OF"
300          fi  #    echo "    appears to match so we'll use it."
301      done  #   for i in $p_FC ; do
302    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
303    #if test -r $p_OF ; then
304    #    OPTFILE=$p_OF
305    #    echo "  The options file:  $p_OF"
306    #    echo "    appears to match so we'll use it."
307    #    break
308    #fi
309    #   done
310      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
311          cat 1>&2 <<EOF          cat 1>&2 <<EOF
312    
# Line 204  get_pdepend_list()  { Line 362  get_pdepend_list()  {
362      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
363          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
364          > ./.pd_tmp          > ./.pd_tmp
365      source ./.pd_tmp      . ./.pd_tmp
366      rm -f ./.pd_tmp      rm -f ./.pd_tmp
367    
368      echo -n "PNAME = "${}      printf "PNAME = "${}
369  }  }
370    
371    
372  #  Explain usage  #  Explain usage
373  usage()  {  usage()  {
374      echo  cat <<EOF
375      echo "Usage: "$0" [OPTIONS]"  
376      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
377      echo    where [OPTIONS] can be:
378      echo "    -help | --help | -h | --h"  
379      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
380      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
381      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
382      echo "    -pdepend NAME | --pdepend NAME"      -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
383      echo "      -pdepend=NAME | --pdepend=NAME"        -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
384      echo "    -pdefault NAME | --pdefault NAME"            Use "NAME" as the adoptfile.  By default, the file at
385      echo "      -pdefault=NAME | --pdefault=NAME"            "tools/adjoint_options/adjoint_default" will be used.
386      echo "    -make NAME | -m NAME"  
387      echo "      --make=NAME | -m=NAME"      -nooptfile | --nooptfile
388      echo "    -makefile NAME | -mf NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
389      echo "      --makefile=NAME | -mf=NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
390      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"            Use "NAME" as the optfile.  By default, an attempt will be
391      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            made to find an appropriate "standard" optfile in the
392      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"            tools/build_options/ directory.
393      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"  
394      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"      -pdepend NAME | --pdepend NAME
395      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"        -pdepend=NAME | --pdepend=NAME
396      echo "    -disable NAME | --disable NAME"            Get package dependency information from "NAME".
397      echo "      -disable=NAME | --disable=NAME"  
398      echo "    -enable NAME | --enable NAME"      -pdefault NAME | --pdefault NAME
399      echo "      -enable=NAME | --enable=NAME"        -pdefault=NAME | --pdefault=NAME
400      echo "    -standarddirs NAME | --standarddirs NAME"            Get the default package list from "NAME".
401      echo "      -standarddirs=NAME | --standarddirs=NAME"  
402      echo "    -noopt NAME | --noopt NAME"      -make NAME | -m NAME
403      echo "      -noopt=NAME | --noopt=NAME"        --make=NAME | -m=NAME
404  #    echo "    -cpp NAME | --cpp NAME"            Use "NAME" for the MAKE program. The default is "make" but
405  #    echo "      -cpp=NAME | --cpp=NAME"            many platforms, "gmake" is the preferred choice.
406      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"  
407      echo "      -fc=NAME | --fc=NAME"      -makefile NAME | -mf NAME
408      echo "    -[no]ieee | --[no]ieee"        --makefile=NAME | -mf=NAME
409      echo "    -[no]mpi | --[no]mpi"            Call the makefile "NAME".  The default is "Makefile".
410      echo "    -[no]jam | --[no]jam"  
411      echo      -makedepend NAME | -md NAME
412      echo "  and NAME is a string such as:"        --makedepend=NAME | -md=NAME
413      echo            Use "NAME" for the MAKEDEPEND program.
414      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"  
415      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
416      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
417      echo            Specify the location of the MITgcm ROOTDIR as "NAME".
418      echo "  which, depending upon your shell, may need to be single-quoted"            By default, genamke will try to find the location by
419      echo "  if it contains spaces, dashes, or other special characters."            looking in parent directories (up to the 5th parent).
420    
421        -mods NAME | --mods NAME | -mo NAME | --mo NAME
422          -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
423              Here, "NAME" specifies a list of directories that are
424              used for additional source code.  Files found in the
425              "mods list" are given preference over files of the same
426              name found elsewhere.
427    
428        -disable NAME | --disable NAME
429          -disable=NAME | --disable=NAME
430              Here "NAME" specifies a list of packages that we don't
431              want to use.  If this violates package dependencies,
432              genamke will exit with an error message.
433    
434        -enable NAME | --enable NAME
435          -enable=NAME | --enable=NAME
436              Here "NAME" specifies a list of packages that we wish
437              to specifically enable.  If this violates package
438              dependencies, genamke will exit with an error message.
439    
440        -standarddirs NAME | --standarddirs NAME
441          -standarddirs=NAME | --standarddirs=NAME
442              Here, "NAME" specifies a list of directories to be
443              used as the "standard" code.
444    
445        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
446          -fc=NAME | --fc=NAME
447              Use "NAME" as the fortran compiler.  By default, genmake
448              will search for a working compiler by trying a list of
449              "usual suspects" such as g77, f77, etc.
450    
451        -[no]ieee | --[no]ieee
452              Do or don't use IEEE numerics.  Note that this option
453              *only* works if it is supported by the OPTFILE that
454              is being used.
455    
456        -mpi | --mpi
457              Include MPI header files and link to MPI libraries
458        -mpi=PATH | --mpi=PATH
459              Include MPI header files and link to MPI libraries using MPI_ROOT
460              set to PATH. i.e. Include files from $PATH/include, link to libraries
461              from $PATH/lib and use binaries from $PATH/bin.
462    
463        -bash NAME
464              Explicitly specify the Bourne or BASH shell to use
465    
466      While it is most often a single word, the "NAME" variables specified
467      above can in many cases be a space-delimited string such as:
468    
469        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
470        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
471        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
472    
473      which, depending upon your shell, may need to be single-quoted.
474    
475      For more detailed genmake documentation, please see:
476    
477        http://mitgcm.org/devel_HOWTO/
478    
479    EOF
480    
481      exit 1      exit 1
482  }  }
483    
484  #eh3 # This is the generic configuration.  #  Build a CPP macro to automate calling C routines from FORTRAN
485  #eh3 set LN         = ( 'ln -s' )  get_fortran_c_namemangling()  {
486  #eh3 set CPP        = ( '/lib/cpp -P' )      default_nm="#define FC_NAMEMANGLE(X) X ## _"
487  #eh3 set S64        = ( '$(TOOLSDIR)/set64bitConst.sh' )      
488  #eh3 set KPP        = (  )      cat > genmake_test.c <<EOF
489  #eh3 set FC         = ( 'f77' )  void tcall( char * string ) { tsub( string ); }
490  #eh3 set LINK       = $FC  EOF
491  #eh3 set MAKEDEPEND = ( 'makedepend' )      $MAKE genmake_test.o >> genmake_warnings 2>&1
492  #eh3 set INCLUDES   = ( -I. )      RETVAL=$?
493  #eh3 set FFLAGS     = (  )      if test "x$RETVAL" != x0 ; then
494  #eh3 set FOPTIM     = (  )          FC_NAMEMANGLE=$default_nm
495  #eh3 set CFLAGS     = (  )          cat <<EOF>> genmake_errors
496  #eh3 set KFLAGS1    = (  )  
497  #eh3 set KFLAGS2    = (  )  WARNING: C test compile fails
498  #eh3 set LIBS       = (  )  WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
499  #eh3 set KPPFILES   = (  )  WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
500  #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = (  )  EOF
501  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )          return 1
502        fi
503        c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
504        RETVAL=$?
505        if test "x$RETVAL" != x0 ; then
506            FC_NAMEMANGLE=$default_nm
507            cat <<EOF>> genmake_warnings
508    
509    WARNING: The "nm" command failed.
510    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
511    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
512    EOF
513            return 1
514        fi
515        cat > genmake_tcomp.f <<EOF
516          subroutine tcall( string )
517          character*(*) string
518          call tsub( string )
519          end
520    EOF
521        $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1
522        RETVAL=$?
523        if test "x$RETVAL" != x0 ; then
524            FC_NAMEMANGLE=$default_nm
525            cat <<EOF>> genmake_warnings
526    
527    WARNING: FORTRAN test compile fails -- please see "genmake_errors"
528    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
529    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
530    EOF
531            return 1
532        fi
533        f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
534        RETVAL=$?
535        if test "x$RETVAL" != x0 ; then
536            FC_NAMEMANGLE=$default_nm
537            cat <<EOF>> genmake_warnings
538    
539    WARNING: The "nm" command failed.
540    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
541    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
542    EOF
543            return 1
544        fi
545    
546        c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
547        f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
548        c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
549        f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
550    
551        nmangle="X"
552        if test "x$c_a" != "x$f_a" ; then
553            comm="echo x$f_a | sed -e 's|x$c_a||'"
554            a=`eval $comm`
555            nmangle="$a ## $nmangle"
556        fi
557        if test "x$c_b" != "x$f_b" ; then
558            comm="echo x$f_b | sed -e 's|x$c_b||'"
559            b=`eval $comm`
560            nmangle="$nmangle ## $b"
561        fi
562    
563        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
564    
565        #  cleanup the testing files
566        rm -f genmake_tcomp.* genmake_test.*
567    }
568    
569    
570    check_HAVE_CLOC()  {
571        get_fortran_c_namemangling
572        cat <<EOF > genmake_tc_1.c
573    $FC_NAMEMANGLE
574    #include <stdio.h>
575    #include <stdlib.h>
576    #include <unistd.h>
577    #include <assert.h>
578    #include <sys/time.h>
579    void FC_NAMEMANGLE(cloc) ( double *curtim )
580    {
581     struct timeval tv1;
582     gettimeofday(&tv1 , (void *)NULL );
583     *curtim =  (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
584     *curtim = *curtim/1.E6;
585    }
586    EOF
587        make genmake_tc_1.o >> genmake_tc.log 2>&1
588        RET_C=$?
589        cat <<EOF > genmake_tc_2.f
590          program hello
591          Real*8 wtime
592          external cloc
593          call cloc(wtime)
594          print *," HELLO WORLD", wtime
595          end program hello
596    EOF
597        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
598        RET_F=$?
599        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
600        RETVAL=$?
601        if test "x$RETVAL" = x0 ; then
602            HAVE_CLOC=t
603            DEFINES="$DEFINES -DHAVE_CLOC"
604        fi
605        rm -f genmake_tc*
606    }
607    
608    
609    check_netcdf_libs()  {
610        cat <<EOF > genmake_tnc.for
611          program fgennc
612    #include "netcdf.inc"
613          integer iret, ncid, xid
614          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
615          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
616          iret = nf_def_dim(ncid, 'X', 11, xid)
617          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
618          iret = nf_close(ncid)
619          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
620          end
621    EOF
622        $CPP genmake_tnc.for > genmake_tnc.f  \
623            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
624        RET_COMPILE=$?
625        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
626        RETVAL=$?
627        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
628            HAVE_NETCDF=t
629        else
630            # try again with "-lnetcdf" added to the libs
631            $CPP genmake_tnc.for > genmake_tnc.f  \
632                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
633                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
634            RET_COMPILE=$?
635            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
636            RETVAL=$?
637            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
638                LIBS="$LIBS -lnetcdf"
639                HAVE_NETCDF=t
640            else
641                cat genmake_tnc.log >> genmake_warnings
642            fi
643        fi
644        rm -f genmake_tnc*
645    }
646    
647    
648    
649    ###############################################################################
650    #   Sequential part of script starts here
651    ###############################################################################
652    
653  #  Set defaults here  #  Set defaults here
654  COMMANDL="$0 $@"  COMMANDL="$0 $@"
# Line 289  LN= Line 658  LN=
658  S64=  S64=
659  KPP=  KPP=
660  FC=  FC=
661    CPP=
662  LINK=  LINK=
663  DEFINES="-DWORDLENGTH=4"  DEFINES=
664  PACKAGES=  PACKAGES=
665  ENABLE=  ENABLE=
666  DISABLE=  DISABLE=
# Line 306  FOPTIM= Line 676  FOPTIM=
676  CFLAGS=  CFLAGS=
677  KFLAGS1=  KFLAGS1=
678  KFLAGS2=  KFLAGS2=
679    #LDADD=
680  LIBS=  LIBS=
681  KPPFILES=  KPPFILES=
682  NOOPTFILES=  NOOPTFILES=
683  NOOPTFLAGS=  NOOPTFLAGS=
684    MPI=
685    MPIPATH=
686    
687    # DEFINES checked by test compilation
688    HAVE_SYSTEM=
689    HAVE_FDATE=
690    FC_NAMEMANGLE=
691    HAVE_CLOC=
692    HAVE_NETCDF=
693    HAVE_ETIME=
694    
695  MODS=  MODS=
696  TOOLSDIR=  TOOLSDIR=
697  SOURCEDIRS=  SOURCEDIRS=
698  INCLUDEDIRS=  INCLUDEDIRS=
699  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
700    
701    G2ARGS=
702    BASH=
703  PWD=`pwd`  PWD=`pwd`
704  MAKE=make  MAKE=make
705  AWK=awk  AWK=awk
# Line 332  IEEE= Line 715  IEEE=
715  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
716      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
717  fi  fi
718    FS=
719    FS90=
720    
721  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
722  AD_OPTFILE=  AD_OPTFILE=
# Line 348  TAMC_EXTRA= Line 733  TAMC_EXTRA=
733    
734    
735  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
736  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
737  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
738    
739  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
740  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
741  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
742  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
743  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
744    gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
745    
746  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
747  gm_s7="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
748  gm_s8="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"  gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
749  gm_s9="TAF_EXTRA TAMC_EXTRA"  gm_s12="TAF_EXTRA TAMC_EXTRA"
750    
751  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7 $gm_s8 $gm_s9"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
752    gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
753    
754    cat <<EOF
755    
756    GENMAKE :
757    
758    A program for GENerating MAKEfiles for the MITgcm project.  For a
759    quick list of options, use "genmake -h" or for more detail see:
760    
761      http://mitgcm.org/devel_HOWTO/
762    
763    EOF
764    
 echo  
765  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
766  gm_local="genmake_local"  gm_local="genmake_local"
767  for i in . $MODS ; do  for i in . $MODS ; do
768      if test -r $i/$gm_local ; then      if test -r $i/$gm_local ; then
769          source $i/$gm_local          . $i/$gm_local
770          break          break
771      fi      fi
772  done  done
773  echo -n "  getting local config information:  "  printf "  getting local config information:  "
774  if test -e $gm_local ; then  if test -e $gm_local ; then
775      echo "using $gm_local"      echo "using $gm_local"
776      source $gm_local      . $gm_local
777      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
778      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
779  else  else
# Line 398  fi Line 794  fi
794  ac_prev=  ac_prev=
795  for ac_option ; do  for ac_option ; do
796    
797        G2ARGS="$G2ARGS \"$ac_option\""
798    
799      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
800      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
801          eval "$ac_prev=\$ac_option"          eval "$ac_prev=\$ac_option"
# Line 419  for ac_option ; do Line 817  for ac_option ; do
817          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
818              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
819                    
820          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
821              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
822          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
823              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 439  for ac_option ; do Line 837  for ac_option ; do
837          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
838              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
839                    
840            -bash | --bash)
841                ac_prev=BASH ;;
842            -bash=* | --bash=*)
843                BASH=$ac_optarg ;;
844            
845            -makedepend | --makedepend | -md | --md)
846                ac_prev=MAKEDEPEND ;;
847            -makedepend=* | --makedepend=* | -md=* | --md=*)
848                MAKEDEPEND=$ac_optarg ;;
849            
850          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
851              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
852          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
853              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
854                    
855          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
856              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
857          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
858              PLATFORM=$ac_optarg ;;              echo
859                usage
860                ;;
861                    
862          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
863              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 474  for ac_option ; do Line 884  for ac_option ; do
884          -standarddirs=* | --standarddirs=*)          -standarddirs=* | --standarddirs=*)
885              STANDARDDIRS=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
886    
         -noopt | --noopt)  
             ac_prev=NOOPT ;;  
         -noopt=* | --noopt=*)  
             NOOPT=$ac_optarg ;;  
           
887  #           -cpp | --cpp)  #           -cpp | --cpp)
888  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
889  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
# Line 489  for ac_option ; do Line 894  for ac_option ; do
894          -fc=* | --fc=*)          -fc=* | --fc=*)
895              FC=$ac_optarg ;;              FC=$ac_optarg ;;
896                    
897            -fs | --fs)
898                ac_prev=FS ;;
899            -fs=* | --fs=*)
900                FS=$ac_optarg ;;
901            
902            -fs90 | --fs90)
903                ac_prev=FS90 ;;
904            -fs90=* | --fs90=*)
905                FS90=$ac_optarg ;;
906            
907          -ieee | --ieee)          -ieee | --ieee)
908              IEEE=true ;;              IEEE=true ;;
909          -noieee | --noieee)          -noieee | --noieee)
910              IEEE= ;;              IEEE= ;;
911            
912          -mpi | --mpi)          -mpi | --mpi)
913              MPI=true ;;              MPI=true ;;
914          -nompi | --nompi)          -mpi=* | --mpi=*)
915              MPI= ;;              MPIPATH=$ac_optarg
916                MPI=true ;;
917                    
918          -jam | --jam)  #       -jam | --jam)
919              JAM=1 ;;  #           JAM=1 ;;
920          -nojam | --nojam)  #       -nojam | --nojam)
921              JAM=0 ;;  #           JAM=0 ;;
922                    
923          -ds | --ds)          -ds | --ds)
924              DUMPSTATE=t ;;              DUMPSTATE=t ;;
# Line 550  if test "x${ROOTDIR}" = x ; then Line 966  if test "x${ROOTDIR}" = x ; then
966          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
967              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
968                  ROOTDIR=$d                  ROOTDIR=$d
969                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
970                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
971                  break                  break
972              fi              fi
# Line 581  fi Line 997  fi
997  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
998      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
999          echo "    using OPTFILE=\"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
1000          source "$OPTFILE"          . "$OPTFILE"
1001          RETVAL=$?          RETVAL=$?
1002          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1003              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
1004              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1005              exit 1              exit 1
1006          fi          fi
# Line 597  if test "x$OPTFILE" != xNONE ; then Line 1013  if test "x$OPTFILE" != xNONE ; then
1013      fi      fi
1014  fi  fi
1015    
1016    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1017    # check_for_broken_Ff
1018    
1019  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1020  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1021      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 608  fi Line 1027  fi
1027  if test "x${AD_OPTFILE}" != xNONE ; then  if test "x${AD_OPTFILE}" != xNONE ; then
1028      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
1029          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
1030          source "$AD_OPTFILE"          . "$AD_OPTFILE"
1031          RETVAL=$?          RETVAL=$?
1032          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1033              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1034              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1035              exit 1              exit 1
1036          fi          fi
# Line 624  if test "x${AD_OPTFILE}" != xNONE ; then Line 1043  if test "x${AD_OPTFILE}" != xNONE ; then
1043      fi      fi
1044  fi  fi
1045    
1046  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1047  #  and abort!  #  either set defaults or complain and abort!
1048    if test ! "x$BASH" = x ; then
1049        # add a trailing space so that it works within the Makefile syntax (see below)
1050        BASH="$BASH "
1051    fi
1052  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1053      cat <<EOF 1>&2      cat <<EOF 1>&2
1054    
# Line 639  fi Line 1062  fi
1062  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1063      LINK=$FC      LINK=$FC
1064  fi  fi
1065    if test "x$MAKE" = x ; then
1066        MAKE="make"
1067    fi
1068  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
1069      CPP="cpp"      CPP=cpp
1070  fi  fi
1071    #EH3 === UGLY ===
1072    #  The following is an ugly little hack to check for $CPP in /lib/ and
1073    #  it should eventually be replaced with a more general function that
1074    #  searches a combo of the user's path and a list of "usual suspects"
1075    #  to find the correct location for binaries such as $CPP.
1076    for i in " " "/lib/" ; do
1077        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1078    done
1079    #EH3 === UGLY ===
1080  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
1081  RETVAL=$?  RETVAL=$?
1082  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 651  Error: C pre-processor "$CPP" failed the Line 1086  Error: C pre-processor "$CPP" failed the
1086    
1087    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
1088    2) the "./genmake_local" file    2) the "./genmake_local" file
1089      3) with the CPP environment variable
1090    
1091  EOF  EOF
1092      exit 1      exit 1
1093  else  else
1094      rm -f test_cpp      rm -f test_cpp
1095  fi  fi
1096  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
1097      MAKEDEPEND=makedepend  if test "x$LN" = x ; then
1098        LN="ln -s"
1099    fi
1100    echo "test" > genmake_test_ln
1101    $LN genmake_test_ln genmake_tlink
1102    RETVAL=$?
1103    if test "x$RETVAL" != x0 ; then
1104        cat <<EOF 1>&2
1105    
1106    Error: The command "ln -s" failed -- please specify a working soft-link
1107      command in the optfile.
1108    
1109    EOF
1110        exit 1
1111    fi
1112    rm -f genmake_test_ln genmake_tlink
1113    
1114    #  Check for broken *.F/*.f handling and fix if possible
1115    check_for_broken_Ff
1116    
1117    if test ! "x$MPI" = x ; then
1118          echo "  Turning on MPI cpp macros"
1119          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1120    fi
1121    
1122    printf "\n===  Checking system libraries  ===\n"
1123    printf "  Do we have the system() command using $FC...  "
1124    cat > genmake_tcomp.f <<EOF
1125          program hello
1126          call system('echo hi')
1127          end
1128    EOF
1129    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1130    RETVAL=$?
1131    if test "x$RETVAL" = x0 ; then
1132        HAVE_SYSTEM=t
1133        DEFINES="$DEFINES -DHAVE_SYSTEM"
1134        echo "yes"
1135    else
1136        HAVE_SYSTEM=
1137        echo "no"
1138    fi
1139    rm -f genmake_tcomp*
1140    
1141    printf "  Do we have the fdate() command using $FC...  "
1142    cat > genmake_tcomp.f <<EOF
1143          program hello
1144          CHARACTER(128) string
1145          string = ' '
1146          call fdate( string )
1147          print *, string
1148          end
1149    EOF
1150    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1151    RETVAL=$?
1152    if test "x$RETVAL" = x0 ; then
1153        HAVE_FDATE=t
1154        DEFINES="$DEFINES -DHAVE_FDATE"
1155        echo "yes"
1156    else
1157        HAVE_FDATE=
1158        echo "no"
1159    fi
1160    rm -f genmake_tcomp*
1161    
1162    printf "  Do we have the etime() command using $FC...  "
1163    cat > genmake_tcomp.f <<EOF
1164          program hello
1165          REAL*4 ACTUAL, TARRAY(2)
1166          EXTERNAL ETIME
1167          REAL*4 ETIME
1168          actual = etime( tarray )
1169          print *, tarray
1170          end
1171    EOF
1172    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1173    RETVAL=$?
1174    if test "x$RETVAL" = x0 ; then
1175        HAVE_ETIME=t
1176        DEFINES="$DEFINES -DHAVE_ETIME"
1177        echo "yes"
1178    else
1179        HAVE_ETIME=
1180        echo "no"
1181    fi
1182    rm -f genmake_tcomp*
1183    
1184    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1185    check_HAVE_CLOC
1186    if test "x$HAVE_CLOC" != x ; then
1187        echo "yes"
1188    else
1189        echo "no"
1190    fi
1191    rm -f genmake_t*
1192    
1193    printf "  Can we create NetCDF-enabled binaries...  "
1194    check_netcdf_libs
1195    if test "x$HAVE_NETCDF" != x ; then
1196        echo "yes"
1197    else
1198        echo "no"
1199  fi  fi
1200    
1201    
1202  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1203  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1204  for d in $MODS ; do  for d in $MODS ; do
1205      if test ! -d $d ; then      if test ! -d $d ; then
1206          echo          echo
1207          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1208          exit 1          exit 1
1209      else      else
1210          echo -n " $d"          printf " $d"
1211          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1212          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1213      fi      fi
# Line 699  if test "x${TOOLSDIR}" = x ; then Line 1237  if test "x${TOOLSDIR}" = x ; then
1237      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1238  fi  fi
1239  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1240      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1241      exit 1      exit 1
1242  fi  fi
1243  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1244      S64='$(TOOLSDIR)/set64bitConst.sh'      S64='$(TOOLSDIR)/set64bitConst.sh'
1245  fi  fi
1246    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1247    
1248  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1249    
# Line 713  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 1252  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1252  #  they appear as regular source code  #  they appear as regular source code
1253  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1254      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
1255      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1256      RETVAL=$?      RETVAL=$?
1257      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
1258          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1259      else      else
1260          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1261          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1262          exit 1          exit 1
1263      fi      fi
1264  fi  fi
1265    
1266    #same for exch2
1267    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1268        echo "  Making source files in exch2 from  templates"
1269        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1270        RETVAL=$?
1271        if test "x${RETVAL}" = x0 ; then
1272            rm -f make_exch2.errors
1273        else
1274            echo "Error: problem encountered while building source files in exch2:"
1275            cat make_exch2.errors 1>&2
1276            exit 1
1277        fi
1278    fi
1279    
1280  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1281  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1282      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 750  if test ! "x${RETVAL}" = x0 ; then Line 1303  if test ! "x${RETVAL}" = x0 ; then
1303      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1304      exit 1      exit 1
1305  fi  fi
1306  source ./.pd_tmp  . ./.pd_tmp
1307  rm -f ./.pd_tmp  rm -f ./.pd_tmp
1308    
1309  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1310  #  file should eventually be added so that, for convenience, one can  #  file should eventually be added so that, for convenience, one can
1311  #  specify groups of packages using names like "ocean" and "atmosphere".  #  specify groups of packages using names like "ocean" and "atmosphere".
1312  echo  -n "  checking default package list:  "  echo "  checking default package list:  "
1313  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1314      for i in "." $MODS ; do      for i in "." $MODS ; do
1315          if test -r $i"/packages.conf" ; then          if test -r $i"/packages.conf" ; then
# Line 769  if test "x${PDEFAULT}" = x ; then Line 1322  if test "x${PDEFAULT}" = x ; then
1322      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1323  fi  fi
1324  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1325      echo "default packages file disabled"      echo "    default packages file disabled"
1326  else  else
1327      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1328          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1329      else      else
1330          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1331          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1332          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1333          RETVAL=$?          RETVAL=$?
1334          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1335              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1336              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1337              exit 1              exit 1
1338          fi          fi
# Line 788  else Line 1340  else
1340              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1341          done          done
1342          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1343          expand_pkg_groups          while ! expand_pkg_groups; do echo > /dev/null; done
1344          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1345      fi      fi
1346  fi  fi
1347    
1348  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1349    for i in $PACKAGES ; do
1350        echo $i >> ./.tmp_pack
1351    done
1352    for i in `grep  "-" ./.tmp_pack` ; do
1353        j=`echo $i | sed 's/[-]//'`
1354        DISABLE="$DISABLE $j"
1355    done
1356  pack=  pack=
1357  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1358      addit="t"      addit="t"
# Line 810  PACKAGES="$pack" Line 1369  PACKAGES="$pack"
1369  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1370  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1371  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1372    # Test if each explicitly referenced package exists
1373  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1374      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1375        if test ! -d "$ROOTDIR/pkg/$j" ; then
1376          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1377          exit 1          exit 1
1378      fi      fi
1379      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1380  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1381  PACKAGES=  PACKAGES=
1382  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1383      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1384  done  done
1385    rm -f ./.tmp_pack
1386  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1387    
1388  echo "  applying package dependency rules"  echo "  applying package dependency rules"
# Line 908  for i in $PACKAGES ; do Line 1468  for i in $PACKAGES ; do
1468      fi      fi
1469  done  done
1470    
1471  #  This is compatible with the old genmake.  The "DISABLE_*" flags  #  Build MNC templates and check for ability to build and use NetCDF
1472  #  need to be replaced by the "ALLOW_*" flags set below.  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1473  #  RETVAL=$?
1474  # echo -n "  Setting package-specific CPP flags:  "  if test "x$RETVAL" = x0 ; then
1475  # pkrm=( mom_fluxform mom_vecinv generic_advdiff )      ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1476  # pkrmdef=( -DDISABLE_MOM_FLUXFORM -DDISABLE_MOM_VECINV -DDISABLE_GENERIC_ADVDIFF -DDISABLE_DEBUGMODE )      RETVAL=$?
1477  # echo -n "  "      if test "x${RETVAL}" = x0 ; then
1478  # i=0          rm -f make_mnc.errors
1479  # while test $i -lt "${#pkrm[@]}" ; do      else
1480  #     echo "$PACKAGES" | grep "${pk[$i]}" > /dev/null 2>&1          echo "Error: problem encountered while building source files in pkg/mnc:"
1481  #     RETVAL=$?          cat make_mnc.errors 1>&2
1482  #     if test "x$RETVAL" = x1 ; then          exit 1
1483  #       DEFINES="$DEFINES ${pkdef[$i]}"      fi
1484  #       echo -n " ${pkdef[$i]}"      if test "x$HAVE_NETCDF" != xt ; then
1485  #     fi          cat <<EOF
 #     i=$(( $i + 1 ))  
 # done  
 # echo  
   
 # Create a list of #define and #undef to enable/disable packages  
 PACKAGES_DOT_H=PACKAGES_CONFIG.h  
 cat <<EOF >$PACKAGES_DOT_H".tmp"  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
1486    
1487  #ifndef PACKAGES_H  WARNING: the "mnc" package has been enabled but tests failed to
1488  #define PACKAGES_H    compile and/or execute NetCDF applications.  Please check that:
1489    
1490  C  Packages disabled by genmake:    1) NetCDF is installed for your compiler and
1491      2) the LIBS variable (within the 'optfile") specifies the correct
1492           NetCDF library to link against.
1493      
1494  EOF  EOF
1495        fi
1496    fi
1497    
1498    # Create a list of #define and #undef to enable/disable packages
1499    PACKAGES_DOT_H=PACKAGES_CONFIG.h
1500  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1501  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1502  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1503  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1504  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1505  all_pack=  all_pack=
1506    DISABLED_PACKAGES=
1507  for n in $names ; do  for n in $names ; do
1508      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1509          has_pack="f"          has_pack="f"
# Line 958  for n in $names ; do Line 1515  for n in $names ; do
1515          done          done
1516          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1517              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1518              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
 #           DEFINES="$DEFINES -U$undef"  
   
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
             case $n in  
                 mom_fluxform)  
                     DEFINES="$DEFINES -DDISABLE_MOM_FLUXFORM"  
                     ;;  
                 mom_vecinv)  
                     DEFINES="$DEFINES -DDISABLE_MOM_VECINV"  
                     ;;  
                 debug)  
                     DEFINES="$DEFINES -DDISABLE_DEBUGMODE"  
                     ;;  
             esac  
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
   
1519          fi          fi
1520      fi      fi
1521  done  done
1522  cat <<EOF >>$PACKAGES_DOT_H".tmp"  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1523  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1524      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1525      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1526  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1527    
1528  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1529      case $i in      case $i in
1530          aim_v23)          aim_v23)
1531              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1532              DEFINES="$DEFINES -DALLOW_AIM"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
             echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"  
1533              ;;              ;;
1534      esac      esac
1535  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1536    
1537  done  done
 cat <<EOF >>$PACKAGES_DOT_H".tmp"  
   
 #endif /* PACKAGES_H */  
 EOF  
   
 if test ! -f $PACKAGES_DOT_H ; then  
     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
 else  
     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     RETVAL=$?  
     if test "x$RETVAL" = x0 ; then  
         rm -f $PACKAGES_DOT_H".tmp"  
     else  
         mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"  
         mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     fi  
 fi  
1538    
1539  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1540  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1541  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1542      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1543  fi  fi
1544  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1545      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1546      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1547          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1548          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1549          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1550      else              exit 1
1551          SOURCEDIRS="$SOURCEDIRS $adr"          else
1552      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1553      adr="$ROOTDIR/$d/inc"          fi
1554      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1555          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1556          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1557          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1558      else              exit 1
1559          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1560      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1561  done          fi
1562        done
1563    fi
1564    
1565  echo " Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1566  echo " of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1567  CPP_OPTIONS=  CPP_OPTIONS=
1568    CPP_EEOPTIONS=
1569  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1570    names=`ls -1 "$ROOTDIR/pkg"`
1571  for i in $spaths ; do  for i in $spaths ; do
1572      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1573      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1574          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1575          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1576          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1577            for n in $names ; do
1578                test_for_package_in_cpp_options $CPP_OPTIONS $n
1579            done
1580        fi
1581        try="$i/CPP_EEOPTIONS.h"
1582        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1583            echo "    found CPP_EEOPTIONS=\"$try\""
1584            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1585    #**** not yet enabled ****
1586    #        test_for_mpi_in_cpp_eeoptions $try
1587    #**** not yet enabled ****
1588            CPP_EEOPTIONS="$try"
1589      fi      fi
1590  done  done
1591  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1592      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1593      exit 1      exit 1
1594  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1595    
1596  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1597  #  compiler.  #  compiler.
# Line 1077  for i in $SOURCEDIRS ; do Line 1606  for i in $SOURCEDIRS ; do
1606      done      done
1607  done  done
1608    
 cat <<EOF > adjoint_sed  
 s/call adopen(/call adopen ( mythid,\\  
      \&           /g  
 s/call adclose(/call adclose( mythid,\\  
      \&           /g  
 s/call adread(/call adread ( mythid,\\  
      \&           /g  
 s/call adwrite(/call adwrite( mythid,\\  
      \&           /g  
   
 EOF  
1609    
1610  echo  echo
1611  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1105  rm -rf .links.tmp Line 1623  rm -rf .links.tmp
1623  mkdir .links.tmp  mkdir .links.tmp
1624  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1625  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1626  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1627  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1628  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1629  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1630  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1631  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1632  for d in $alldirs ; do  for d in $alldirs ; do
1633      deplist=      deplist=
# Line 1118  for d in $alldirs ; do Line 1636  for d in $alldirs ; do
1636      for sf in $sfiles ; do      for sf in $sfiles ; do
1637          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1638              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1639                    case $d/$sf in
1640                      ./$PACKAGES_DOT_H)
1641                            ;;
1642                      ./AD_CONFIG.h)
1643                            ;;
1644                      ./FC_NAMEMANGLE.h)
1645                            ;;
1646                      *)
1647                            touch .links.tmp/$sf
1648                            deplist="$deplist $sf"
1649                            ;;
1650                    esac
1651                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
                 touch .links.tmp/$sf  
                 deplist="$deplist $sf"  
1652                  case $extn in                  case $extn in
1653                      F)                      F)
1654                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1655                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1656                          ;;                          ;;
1657                      F90)                      F90)
1658                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1659                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1660                          ;;                          ;;
1661                      c)                      c)
1662                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1663                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1664                          ;;                          ;;
1665                      h)                      h)
1666                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1667                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1668                          ;;                          ;;
1669                      flow)                      flow)
1670                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1671                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1672                          ;;                          ;;
1673                  esac                  esac
1674              fi              fi
# Line 1169  echo "#    $MACHINE" >> $MAKEFILE Line 1697  echo "#    $MACHINE" >> $MAKEFILE
1697  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1698  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1699  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1700  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1701  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1702  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1703    
1704    EXE_AD=$EXECUTABLE"_ad"
1705    EXE_FTL=$EXECUTABLE"_ftl"
1706    EXE_SVD=$EXECUTABLE"_svd"
1707    
1708  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1709    #
1710    # OPTFILE="$OPTFILE"
1711  #  #
1712  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1713  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1202  TOOLSDIR    = ${TOOLSDIR} Line 1737  TOOLSDIR    = ${TOOLSDIR}
1737    
1738  #eh3  new defines for the adjoint work  #eh3  new defines for the adjoint work
1739  AUTODIFF    = ${ROOTDIR}/pkg/autodiff  AUTODIFF    = ${ROOTDIR}/pkg/autodiff
1740    EXE_AD      = ${EXE_AD}
1741    EXE_FTL     = ${EXE_FTL}
1742    EXE_SVD     = ${EXE_SVD}
1743    
1744    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1745    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1746    
1747    # These files are created by Makefile
1748    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1749    
1750  EOF  EOF
1751    
# Line 1221  FC = ${FC} Line 1765  FC = ${FC}
1765  # Fortran compiler  # Fortran compiler
1766  F90C = ${F90C}  F90C = ${F90C}
1767  # Link editor  # Link editor
1768  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1769    
1770  # Defines for CPP  # Defines for CPP
1771  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1253  cat csrclist.inc      >> $MAKEFILE Line 1797  cat csrclist.inc      >> $MAKEFILE
1797  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1798  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1799  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1800  echo               >> $MAKEFILE  echo >> $MAKEFILE
1801  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1802  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1803  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1804    echo >> $MAKEFILE
1805    echo '.SUFFIXES:' >> $MAKEFILE
1806    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
1807  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1808  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
1809    
1810  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1811    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
1812  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1813  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1814            @echo Creating \$@ ...
1815          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1816  depend:  depend:
1817          @make links          @make links
1818          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1819          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1820            -rm -f makedepend.out
1821    
1822  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1823    
1824  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1825    
# Line 1283  output.txt: \$(EXECUTABLE) Line 1828  output.txt: \$(EXECUTABLE)
1828          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1829    
1830  clean:  clean:
1831          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
1832  Clean:  Clean:
1833          @make clean          @make clean
1834          @make cleanlinks          @make cleanlinks
1835          -rm -f Makefile.bak genmake_state genmake_optfile make.log          -rm -f \$(SPECIAL_FILES)
1836            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1837  CLEAN:  CLEAN:
1838          @make Clean          @make Clean
1839          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1840          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1841          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1842          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
1843    
1844  Makefile: makefile  #eh3 Makefile: makefile
1845  makefile:  makefile:
1846          ${0} $@          $THIS_SCRIPT $G2ARGS
1847  cleanlinks:  cleanlinks:
1848          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1849    
1850  # The normal chain of rules is (  .F - .f - .o  )  # Special targets ($SPECIAL_FILES) which are create by make
1851  .F.f:  ${PACKAGES_DOT_H}:
1852            @echo Creating \$@ ...
1853            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1854    AD_CONFIG.h:
1855            @echo Creating \$@ ...
1856            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1857    FC_NAMEMANGLE.h:
1858            @echo Creating \$@ ...
1859            echo "$FC_NAMEMANGLE" > \$@
1860    
1861    # The normal chain of rules is (  .F - .$FS - .o  )
1862    
1863    %.o : %.F
1864    
1865    .F.$FS:
1866          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1867  .f.o:  .$FS.o:
1868          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1869  .F90.f90:  .F90.$FS90:
1870          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1871  .f90.o:  .$FS90.o:
1872          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1873  .c.o:  .c.o:
1874          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
1875    
1876  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
1877  .F.p:  .F.p:
1878          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1879  .p.f:  .p.$FS:
1880          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1881    
1882  #=========================================  #=========================================
# Line 1343  done Line 1903  done
1903    
1904  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
1905  echo >> $MAKEFILE  echo >> $MAKEFILE
1906  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
1907  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
1908  for i in $AD_FILES ; do  for i in $AD_FILES ; do
1909      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
1910      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
1911  done  done
1912  echo >> $MAKEFILE  echo >> $MAKEFILE
1913    rm -f ad_files
1914    
1915  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1916    
1917  ad_input_code.f: \$(F77FILES)  # ... AD ...
1918    adall: ad_taf
1919    adtaf: ad_taf_output.f
1920    adtamc: ad_tamc_output.f
1921    
1922    ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1923            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1924            cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1925            -rm -f ad_config.template
1926            @make \$(F77FILES)
1927          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1928          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1929    
 # ... AD ...  
1930  ad_taf_output.f: ad_input_code.f  ad_taf_output.f: ad_input_code.f
1931          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1932          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1933    
1934    adtafonly:
1935            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1936            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1937    
1938  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
1939          \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1940    
1941  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.f: ad_input_code.f
1942          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1943          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
1944    
1945  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
1946          \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
1947    
1948    
1949    # ... FTL ...
1950    ftlall: ftl_taf
1951    ftltaf: ftl_taf_output.f
1952    ftltamc: ftl_tamc_output.f
1953    
1954    ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1955            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1956            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1957            -rm -f ftl_config.template
1958            @make \$(F77FILES)
1959            @make \$(AD_FLOW_FILES)
1960            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1961    
1962    ftl_taf_output.f: ftl_input_code.f
1963            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1964            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1965    
1966  # ... FLT ...  ftltafonly:
1967  flt_taf_output.f: ad_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1968          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
         cat ad_input_code_ad.f | sed -f adjoint_sed > flt_taf_output.f  
1969    
1970  flt_taf: flt_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
1971          \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) flt_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1972    
1973  flt_tamc_output.f: ad_input_code.f  ftl_tamc_output.f: ftl_input_code.f
1974          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1975          cat ad_input_code_ad.f | sed -f adjoint_sed > flt_tamc_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
1976    
1977  flt_tamc: flt_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1978          \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) flt_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1979    
1980    
1981  # ... SVD ...  # ... SVD ...
1982  svd_taf_output.f: ad_input_code.f  svdtaf: ad_taf_output.f ftl_taf_output.f
1983          \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f  svdall: svd_taf
         cat ad_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f  
1984    
1985  svd_taf: svd_taf_output.o \$(OBJFILES)  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)
1986          \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
1987    
1988    
1989  #=========================================  #=========================================
# Line 1413  for i in $KPPFILES ; do Line 2001  for i in $KPPFILES ; do
2001      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2002          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2003      fi      fi
2004      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2005  done  done
2006    
2007  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1423  for i in $NOOPTFILES ; do Line 2011  for i in $NOOPTFILES ; do
2011      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2012          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2013      fi      fi
2014      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2015      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2016  done  done
2017    
# Line 1436  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2024  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2024    
2025  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2026    
2027    # Create special header files
2028    $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2029    if test ! -f $PACKAGES_DOT_H ; then
2030        mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2031    else
2032        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2033        RETVAL=$?
2034        if test "x$RETVAL" = x0 ; then
2035            rm -f $PACKAGES_DOT_H".tmp"
2036        else
2037            mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
2038            mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2039        fi
2040    fi
2041    if test ! -f AD_CONFIG.h ; then
2042        $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2043    fi
2044    
2045    
2046  #  Write the "state" for future records  #  Write the "state" for future records
2047  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2048      echo -n "" > genmake_state      printf "" > genmake_state
2049      for i in $gm_state ; do      for i in $gm_state ; do
2050          t1="t2=\$$i"          t1="t2=\$$i"
2051          eval $t1          eval $t1

Legend:
Removed from v.1.17  
changed lines
  Added in v.1.85

  ViewVC Help
Powered by ViewVC 1.1.22